import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';

import 'package:puzzlegame/cubit/game_cubit.dart';
import 'package:puzzlegame/models/game/game.dart';

class GameTipWidget extends StatelessWidget {
  const GameTipWidget({super.key});

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<GameCubit, GameState>(
      builder: (BuildContext context, GameState gameState) {
        final Game currentGame = gameState.currentGame;

        final String asset = 'assets/images/${currentGame.image}.png';
        precacheImage(AssetImage(asset), context);

        return TextButton(
          child: Container(
            decoration: BoxDecoration(
              color: Colors.blue,
              borderRadius: BorderRadius.circular(4),
              border: Border.all(
                color: Colors.blue,
                width: 4,
              ),
            ),
            child: Image(
              height: currentGame.tileSize,
              image: AssetImage(
                currentGame.displayTip ? asset : 'assets/ui/tip_hidden.png',
              ),
              fit: BoxFit.fill,
            ),
          ),
          onPressed: () {
            BlocProvider.of<GameCubit>(context).toggleDisplayTipImage();
          },
        );
      },
    );
  }
}
